;-Global
Global jaPBe_Handle
Global jaPBe_Version

Global jaPBe_FileName.s
Global jaPBe_Selection
Global jaPBe_CurrentWord
Global jaPBe_CompleteText
Global jaPBe_CurrentLine

#timeout=5000

;-Window-Message
#mywm_Plugin_GetCurrentFileName = #wm_user+12
#mywm_Plugin_GetSelection       = #wm_user+13
#mywm_Plugin_GetCurrentWord     = #wm_user+14
#mywm_plugin_GetCompleteText    = #wm_user+15
#mywm_plugin_GetCurrentLine     = #wm_user+16
#mywm_plugin_GetCurrentPosition = #wm_user+17
#mywm_Plugin_Cancel             = #wm_user+18
#mywm_plugin_DisablejaPBe       = #wm_user+19
#mywm_plugin_EnablejaPBe        = #wm_user+20

;-Window-CopyData
#WMCD_OpenFile            = 1
#WMCD_InsertText          = 2
#wmCD_ReplaceCompleteText = 3
#wmcd_ReplaceCurrentLine  = 4
#wmcd_NewText             = 5

Procedure SendDataS(ziel,type,Message$)
  cd.copydatastruct
  cd\dwData=type
  cd\cbData=Len(Message$)+1
  cd\lpData=@Message$
  ProcedureReturn SendMessage_(ziel,#wm_copydata,WindowID(1),cd)
EndProcedure
Procedure SendData(ziel,type,adr,len)
  cd.copydatastruct
  cd\dwData=type
  cd\cbData=len + 1
  cd\lpData=adr
  ProcedureReturn SendMessage_(ziel,#wm_copydata,WindowID(1),cd)
EndProcedure

Procedure Callback(WindowID, Message, wParam, lParam) 
  Result = #PB_ProcessPureBasicEvents 
  If Message=#wm_copydata
    *cd.copydatastruct=lParam
    Result=#False
    If wParam=jaPBe_Handle
      Select *cd\dwData
        Case #mywm_Plugin_GetCurrentFileName
          jaPBe_FileName=PeekS(*cd\lpData)
          Result=#True
        Case #mywm_Plugin_GetSelection
          jaPBe_Selection=GlobalAlloc_(#GMEM_FIXED,*cd\cbData)
          If jaPBe_Selection
            CopyMemory(*cd\lpData,jaPBe_Selection,*cd\cbData)
            Result=#True
          EndIf
        Case #mywm_Plugin_GetCurrentWord
          jaPBe_CurrentWord=GlobalAlloc_(#GMEM_FIXED,*cd\cbData)
          If jaPBe_CurrentWord
            CopyMemory(*cd\lpData,jaPBe_CurrentWord,*cd\cbData)
            Result=#True
          EndIf
        Case #mywm_plugin_GetCompleteText
          jaPBe_CompleteText=GlobalAlloc_(#GMEM_FIXED,*cd\cbData)
          If jaPBe_CompleteText
            CopyMemory(*cd\lpData,jaPBe_CompleteText,*cd\cbData)
            Result=#True
          EndIf
        Case #mywm_plugin_GetCurrentLine
          jaPBe_CurrentLine=GlobalAlloc_(#GMEM_FIXED,*cd\cbData)
          If jaPBe_CurrentLine
            CopyMemory(*cd\lpData,jaPBe_CurrentLine,*cd\cbData)
            Result=#True
          EndIf
      EndSelect
    Else
      MessageRequester("example","Illegaler Sender",0)
    EndIf
  EndIf
  
  ProcedureReturn Result 
EndProcedure 
;-Send
Procedure jaPBe_OpenFile(a$)
  SendDataS(jaPBe_Handle,#WMCD_OpenFile,a$)
EndProcedure
Procedure jaPBe_InsertTextS(a$)
  SendDataS(jaPBe_Handle,#WMCD_InsertText,a$)
EndProcedure
Procedure jaPBe_InsertText(adr,len)
  SendData(jaPBe_Handle,#WMCD_InsertText,adr,len)
EndProcedure
Procedure jaPBe_ReplaceTextS(a$)
  SendDataS(jaPBe_Handle,#wmCD_ReplaceCompleteText,a$)
EndProcedure
Procedure jaPBe_ReplaceText(adr,len)
  SendData(jaPBe_Handle,#wmCD_ReplaceCompleteText,adr,len)
EndProcedure
Procedure jaPBe_ReplaceCurrentLineS(a$)
  SendDataS(jaPBe_Handle,#wmcd_ReplaceCurrentLine,a$)
EndProcedure
Procedure jaPBe_ReplaceCurrentLine(adr,len)
  SendData(jaPBe_Handle,#wmcd_ReplaceCurrentLine,adr,len)
EndProcedure
Procedure jaPBe_NewTextS(a$)
  SendDataS(jaPBe_Handle,#wmcd_NewText,a$)
EndProcedure
Procedure jaPBe_NewText(adr,len)
  SendData(jaPBe_Handle,#wmcd_NewText,adr,len)
EndProcedure
;-Get
;Waring: This routines use windowevent(), so maybe you lost messages
Procedure.s jaPBe_GetCurrentFileName()
  jaPBe_FileName=""
  If SendMessage_(jaPBe_Handle,#mywm_Plugin_GetCurrentFileName,0,WindowID(1))
    timeout=gettickcount_()+#timeout ;maximal 5 sekunden warten
    Repeat
      WindowEvent()
      Delay(1)
    Until jaPBe_FileName<>"" Or gettickcount_()>timeout
  EndIf
  ProcedureReturn jaPBe_FileName
EndProcedure
Procedure jaPBe_GetSelection()
  If jaPBe_Selection
    GlobalFree_(jaPBe_Selection)
    jaPBe_Selection=0
  EndIf
  If SendMessage_(jaPBe_Handle,#mywm_Plugin_GetSelection,0,WindowID(1))
    timeout=gettickcount_()+#timeout ;maximal 5 sekunden warten
    Repeat
      WindowEvent()
      Delay(1)
    Until jaPBe_Selection Or gettickcount_()>timeout
  EndIf
  ProcedureReturn jaPBe_Selection
EndProcedure
Procedure.s jaPBe_GetSelectionS()
  Result=jaPBe_GetSelection()
  If Result
    ProcedureReturn PeekS(Result)
  Else
    ProcedureReturn ""
  EndIf
EndProcedure
Procedure jaPBe_GetCurrentWord()
  If jaPBe_CurrentWord
    GlobalFree_(jaPBe_CurrentWord)
    jaPBe_Selection=0
  EndIf
  If SendMessage_(jaPBe_Handle,#mywm_Plugin_GetCurrentWord,0,WindowID(1))
    timeout=gettickcount_()+#timeout ;maximal 5 sekunden warten
    Repeat
      WindowEvent()
      Delay(1)
    Until jaPBe_CurrentWord Or gettickcount_()>timeout
  EndIf
  ProcedureReturn jaPBe_CurrentWord
EndProcedure
Procedure.s jaPBe_GetCurrentWordS()
  Result=jaPBe_GetCurrentWord()
  If Result
    ProcedureReturn PeekS(Result)
  Else
    ProcedureReturn ""
  EndIf
EndProcedure
Procedure jaPBe_GetCompleteText()
  If jaPBe_CompleteText
    GlobalFree_(jaPBe_CompleteText)
    jaPBe_CompleteText=0
  EndIf
  If SendMessage_(jaPBe_Handle,#mywm_plugin_GetCompleteText,0,WindowID(1))
    timeout=gettickcount_()+#timeout ;maximal 5 sekunden warten
    Repeat
      WindowEvent()
      Delay(1)
    Until jaPBe_CompleteText Or gettickcount_()>timeout
  EndIf
  ProcedureReturn jaPBe_CompleteText
EndProcedure
Procedure.s jaPBe_GetCompleteTextS()
  Result=jaPBe_GetCompleteText()
  If Result
    ProcedureReturn PeekS(Result)
  Else
    ProcedureReturn ""
  EndIf
EndProcedure
Procedure jaPBe_GetCurrentLine()
  If jaPBe_CurrentLine
    GlobalFree_(jaPBe_CurrentLine)
    jaPBe_CurrentLine=0
  EndIf
  If SendMessage_(jaPBe_Handle,#mywm_plugin_GetCurrentLine,0,WindowID(1))
    timeout=gettickcount_()+#timeout ;maximal 5 sekunden warten
    Repeat
      WindowEvent()
      Delay(1)
    Until jaPBe_CurrentLine Or gettickcount_()>timeout
  EndIf
  ProcedureReturn jaPBe_CurrentLine
EndProcedure
Procedure.s jaPBe_GetCurrentLineS()
  Result=jaPBe_GetCurrentLine()
  If Result
    ProcedureReturn PeekS(Result)
  Else
    ProcedureReturn ""
  EndIf
EndProcedure
Procedure jaPBe_GetCurrentPos()
  ProcedureReturn SendMessage_(jaPBe_Handle,#mywm_plugin_GetCurrentPosition,0,WindowID(1))
EndProcedure
Procedure jaPBe_EnablejaPBe()
  ProcedureReturn PostMessage_(jaPBe_Handle,#mywm_plugin_EnablejaPBe,0,WindowID(1))
EndProcedure
Procedure jaPBe_DisablejaPBe()
  ProcedureReturn PostMessage_(jaPBe_Handle,#mywm_plugin_DisablejaPBe,0,WindowID(1))
EndProcedure

If OpenWindow(1,0,200,200,200,#PB_Window_Invisible,"jaPBe-Plugin")
  SetWindowCallback(@Callback())
  a$=ProgramParameter()
  If a$="jaPBe"
    jaPBe_Handle=Val(ProgramParameter())
    jaPBe_Version$=ProgramParameter()

    File.s=jaPBe_GetCurrentFileName()
    Sel.s=jaPBe_GetSelectionS()
    word.s=jaPBe_GetCurrentWordS()
    line.s=jaPBe_GetCurrentLineS()
    text=jaPBe_GetCompleteText()
    pos=jaPBe_GetCurrentPos()
    
    crlf.s=Chr(13)+Chr(10)
    jaPBe_NewTextS("; This is a little example of a plugin"+crlf)
    jaPBe_InsertTextS("; You use jaPBe V"+jaPBe_Version$+crlf)
    If Sel
      jaPBe_InsertTextS("; You have selected this:"+crlf)
      jaPBe_InsertTextS(Sel+crlf)
    Else
      jaPBe_InsertTextS("; You have selected nothing!"+crlf)
    EndIf
    If word
      jaPBe_InsertTextS("; The word under the cursor is:"+crlf)
      jaPBe_InsertTextS(word+crlf)
    Else
      jaPBe_InsertTextS("; There is no word under the cursor"+crlf)
    EndIf
    If line
      jaPBe_InsertTextS("; The text of the cursor-line"+crlf)
      jaPBe_InsertTextS(line+crlf)
    Else
      jaPBe_InsertTextS("; The line under the cursor was empty"+crlf)
    EndIf
    jaPBe_InsertTextS("; as you see, the editor is disabled, you can't do anything!"+crlf)
    For i=2 To 0 Step -1
      Delay(1000)
      jaPBe_InsertTextS(".")
    Next
    jaPBe_InsertTextS(crlf+"; Now i give the editor for 5 seconds free"+crlf)
    jaPBe_EnablejaPBe()
    Delay(5000)
    jaPBe_DisablejaPBe()
    jaPBe_InsertTextS("; ok, engouht!"+crlf)
    jaPBe_InsertTextS("; now a little bit stat:"+crlf)
    jaPBe_InsertTextS("; Name of the file:"+File+crlf)
    jaPBe_InsertTextS("; The cursor was on Position:"+Str(pos)+crlf)
    If text
      len=MemoryStringLength(text)
      If len
        jaPBe_InsertTextS("; The lenght of the file:"+Str(len)+crlf)
        jaPBe_InsertTextS("; The CRC-Checksum:"+Hex(CRC32Fingerprint(text,len))+crlf)
        Dim stat(255)
        *start.Byte=text
        For i=1 To len
          stat(*start\b&$FF)+1
          *start+1
        Next
        stat.s=""
        For i=0 To 255
          If stat(i)
            If i<32 Or i=127
              stat+Str(i)+"   x "+Str(stat(i))+crlf
            Else
              stat+Str(i)+" "+Chr(i)+" x "+Str(stat(i))+crlf
            EndIf
          EndIf
        Next
        jaPBe_InsertTextS(stat)
      Else
        jaPBe_InsertTextS("; no text"+crlf)
      EndIf
    Else
      jaPBe_InsertTextS("; no text"+crlf)
    EndIf
      

    ;Important: Never delete the follow line!
    PostMessage_(jaPBe_Handle,#mywm_Plugin_Cancel,0,WindowID(1))
  Else
    MessageRequester("jaPBe Plugin","This is a jaPBe-Plugin"+Chr(10)+"You can't run it without jaPBe",0)
  EndIf
  CloseWindow(1)
Else
  MessageRequester("jaPBe Plugin","Can't open a window!",0)
EndIf

;Free some stuff
If jaPBe_Selection
  GlobalFree_(jaPBe_Selection)
EndIf
If jaPBe_CurrentWord
  GlobalFree_(jaPBe_CurrentWord)
EndIf
If jaPBe_CompleteText
  GlobalFree_(jaPBe_CompleteText)
EndIf
If jaPBe_CurrentLine
  GlobalFree_(jaPBe_CurrentLine)
EndIf

End