;info:Advanced Preferences
;Pref_Advanced.pbi


XIncludeFile "InMemory.pbi"
XIncludeFile "API-FileHandle.PBI"

Global *PrefMem_.SaveInMemory_,Pref_Changed_,Pref_File_$
Global *Pref_Group_,*Pref_GroupHead_
Global *Pref_Key_

Procedure OpenPref(file$); - Open a Preference, Return #True, when a prefercefile is readed
  Pref_File_$=File$
  Result=#False
  *save=GetInMemory()
  If *PrefMem_
    SetInMemory(*PrefMem_)
    FreeInMemory()
  EndIf
  CreateInMemory()
  *Pref_Group_=0:*Pref_GroupHead_=0:Pref_Changed_=#False
  If API_FileRead(File.API_FileHandle,File$)
    While API_EOF(File)=0
      a$=API_ReadString(File)
      Select Asc(a$)
        Case ';';comments
        Case '['
          Group$=Mid(a$,2,FindString(a$,"]",0)-2)
          StringInMemory(@"[")
          StringInMemory(@Group$)
        Default
          a=FindString(a$,"=",1)
          If a
            Key$=Left(a$,a-1):If Right(Key$,1)=" ": Key$=Left(Key$,Len(Key$)-1) : EndIf
            Value$=Right(a$,Len(a$)-a):If Left(Value$,1)=" ": Value$=Right(Value$,Len(Value$)-1) : EndIf
            StringInMemory(@Key$)
            StringInMemory(@Value$)
          EndIf
      EndSelect
    Wend
    API_CloseFile(File)
    Result=#True
  EndIf

  *PrefMem_=GetInMemory()
  SetInMemory(*save)
  ProcedureReturn Result
EndProcedure
Procedure Pref_FindGroup(Group$); - Set aktive group and return #True, when group exist
  Result=#False
  *save=GetInMemory()
  SetInMemory(*PrefMem_)
  
  
  ResetReadInMemory()
  While CanReadInMemory() And Result=#False
    *Pref_GroupHead_=GetReadInMemory()
    Key$=StringOutMemory():Value$=StringOutMemory()
    If Key$="["
      If UCase(Value$)=UCase(Group$)
        Result=#True
        *Pref_Group_=GetReadInMemory() 
      EndIf
    EndIf
  Wend
  If Result=#False
    *Pref_GroupHead_=0
  EndIf
   
  *PrefMem_=GetInMemory()
  SetInMemory(*save)
    
  ProcedureReturn Result
EndProcedure
Procedure Pref_CreateGroup(Group$); - Set aktive group and create a group, when not exist
  If Pref_FindGroup(Group$)=#False
    *save=GetInMemory()
    SetInMemory(*PrefMem_)
    ResetWriteInMemory()
    *Pref_GroupHead_=GetWriteInMemory()
    AddStringInMemory(@"[")
    AddStringInMemory(@Group$)
    *Pref_Group_=GetWriteInMemory()
    Pref_Changed_=#True
    *PrefMem_=GetInMemory()
    SetInMemory(*save)
  EndIf
EndProcedure
Procedure Pref_DeleteGroup(Group$); - Remove a group
  If Pref_FindGroup(Group$)
    *save=GetInMemory()
    SetInMemory(*PrefMem_)
    break_=#False
    Repeat
      SetPosInMemory(*Pref_GroupHead_)
      Debug RemoveStringOutMemory()+" "+RemoveStringOutMemory()
      If CanReadInMemory()
        a$=StringOutMemory()
        If a$="["
          break_=#True
        EndIf
      Else
        break_=#True
      EndIf
    Until break_
    *Pref_GroupHead_=0
    *Pref_Group_=0
     
    Pref_Changed_=#True
    *PrefMem_=GetInMemory()
    SetInMemory(*save)
  EndIf
EndProcedure
Procedure.s Pref_FindKey(FindKey$,Def$); Find a key and return his value (or Def$ if key not exist)
  *save=GetInMemory()
  SetInMemory(*PrefMem_)
  FindValue$=Def$
  *Pref_Key_=0
  
  If *Pref_Group_
    SetReadInMemory(*Pref_Group_)
  Else
    ResetReadInMemory()
  EndIf
  
  ok=#True
  While CanReadInMemory() And ok
    *key=GetReadInMemory()
    Key$=StringOutMemory():Value$=StringOutMemory()
    If Key$="[" 
      ok=#False
    Else
      If UCase(Key$)=UCase(FindKey$)
        ok=#False
        FindValue$=Value$
        *Pref_Key_=*key
      EndIf
    EndIf
  Wend
  
  *PrefMem_=GetInMemory()
  SetInMemory(*save)
  
  ProcedureReturn FindValue$
EndProcedure
Procedure Pref_SetKey(FindKey$,Value$); Set a value and create a key, if not exist
  Pref_FindKey(FindKey$,"")
  *save=GetInMemory()
  SetInMemory(*PrefMem_)
  If *Pref_Key_
    SetPosInMemory(*Pref_Key_)
    StringOutMemory()
    WriteToReadInMemory()
    RemoveStringOutMemory()
    AddStringInMemory(@Value$)
  Else
    SetPosInMemory(*Pref_Group_)
    AddStringInMemory(@FindKey$)
    AddStringInMemory(@Value$)
  EndIf
  Pref_Changed_=#True
  
  *PrefMem_=GetInMemory()
  SetInMemory(*save)
EndProcedure
Procedure Pref_DeleteKey(FindKey$); Remove a key
  Pref_FindKey(FindKey$,"")
  *save=GetInMemory()
  SetInMemory(*PrefMem_)
  If *Pref_Key_
    SetPosInMemory(*Pref_Key_)
    RemoveStringOutMemory()
    RemoveStringOutMemory()
  EndIf
  Pref_Changed_=#True
  
  *PrefMem_=GetInMemory()
  SetInMemory(*save)
EndProcedure
Procedure ClosePref(); Close preferences and save all changes
  *save=GetInMemory()
  SetInMemory(*PrefMem_)
  
  result=#True
  If Pref_Changed_
    If API_FileCreate(File.API_FileHandle,Pref_File_$)
      ResetReadInMemory()
      While CanReadInMemory()
        Key$=StringOutMemory():Value$=StringOutMemory()
        If Key$="["
          API_WriteStringN(File,"["+Value$+"]")
        Else
          API_WriteStringN(File,Key$+" = "+Value$)
        EndIf
      Wend
      API_CloseFile(File)
    Else
      result=#False
    EndIf
  EndIf
  
  FreeInMemory()
  SetInMemory(*save)
  ProcedureReturn result
EndProcedure
 
; jaPBe Version=1.3.10.24
; Include=InMemory.pbi
; Include=API-FileHandle.pbi
; Build=0
; Language=0x0000 Language Neutral
; FirstLine=26
; CursorPosition=104
; ExecutableFormat=Windows
; EOF